=== modified file 'Makefile'
--- Makefile	2009-10-25 19:16:56 +0000
+++ Makefile	2009-11-01 00:10:28 +0000
@@ -8,10 +8,13 @@
 #	-Wunreachable-code 
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
-# <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>
+# <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
+# and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 LINK_FORTIFY_LD=-z relro -z now
 LINK_FORTIFY=
+
+# If BROKEN_PIE is set, do not build with -pie
 ifndef BROKEN_PIE
 FORTIFY += -fPIE
 LINK_FORTIFY_LD += -fPIE
@@ -55,7 +58,7 @@
 LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
-DOCBOOKTOMAN=cd $(dir $<); xsltproc --nonet --xinclude \
+DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
 	--param man.charmap.use.subset		0 \
 	--param make.year.ranges		1 \
 	--param make.single.year.ranges		1 \
@@ -63,11 +66,11 @@
 	--param man.authors.section.enabled	0 \
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@)
+	$(MANPOST) $(notdir $@))
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
-DOCBOOKTOHTML=xsltproc --nonet --xinclude \
+DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
 	--param make.single.year.ranges		1 \
 	--param man.output.quietly		1 \
@@ -75,7 +78,7 @@
 	--param citerefentry.link		1 \
 	--output $@ \
 	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
-	$<; $(HTMLPOST) $@
+	$<; $(HTMLPOST) $@)
 # Fix citerefentry links
 HTMLPOST=$(SED) --in-place \
 	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
@@ -156,39 +159,39 @@
 
 # Update all these files with version number $(version)
 common.ent: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(<!ENTITY version "\)[^"]*">$$/\1$(version)">/' \
-		$@
+		$@)
 
 mandos: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@
+		$@)
 
 mandos-keygen: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
-		$@
+		$@)
 
 mandos-ctl: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
-		$@
+		$@)
 
 mandos.lsm: Makefile
-	$(SED) --in-place \
+	$(strip $(SED) --in-place \
 		--expression='s/^\(Version:\).*/\1\t$(version)/' \
-		$@
-	$(SED) --in-place \
+		$@)
+	$(strip $(SED) --in-place \
 		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
-		$@
-	$(SED) --in-place \
+		$@)
+	$(strip $(SED) --in-place \
 		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
-		$@
+		$@)
 
-plugins.d/mandos-client: plugins.d/mandos-client.o
-	$(LINK.o) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) \
-		$(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+plugins.d/mandos-client: plugins.d/mandos-client.c
+	$(LINK.c) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) $(strip\
+		) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
 
 .PHONY : all doc html clean distclean run-client run-server install \
 	install-server install-client uninstall uninstall-server \

=== modified file 'TODO'
--- TODO	2009-09-17 11:47:22 +0000
+++ TODO	2009-11-01 00:10:28 +0000
@@ -2,7 +2,8 @@
 
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
 ** TODO [#B] Retry a server which has a non-definite reply:
 *** A closed connection during the TLS handshake
 *** A TCP timeout
@@ -10,22 +11,30 @@
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
 
 * usplash
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
 
 * askpass-fifo
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
 ** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
-** TODO [#B] Prefix all debug output with "Mandos plugin " + argv[0]
+** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
+** TODO use error() instead of perror()
+** TODO lock stdin (with flock()?)
+
+* TODO passdev
 
 * plugin-runner
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
+** TODO use error() instead of perror()
 
 * mandos (server)
 ** TODO [#B] Log level				:BUGS:
@@ -46,11 +55,19 @@
 ** TODO Date+time on console log messages	:BUGS:
    Is this the default?
 ** TODO DBusServiceObjectUsingSuper
-** Global enable/disable flag
-** By-client countdown on secrets given
-** Fix problem with fsck taking a really long time
+** TODO Global enable/disable flag
+** TODO By-client countdown on secrets given
+** TODO Fix problem with fsck taking a really long time
    Whenever a client successfully gets a secret it could get a
    one-time timeout boost to allow for an fsck-incurred delay
+** TODO Delay before client receives key
+   This would give an operator opportunity to cancel the request if
+   desired.
+** TODO Client manual approval mode
+   A client needs manual approval on the server before it gets the
+   secret
+** TODO Persistent state
+   /var/lib/mandos/*
 
 * mandos.xml
 ** [[file:mandos.xml::XXX][Document D-Bus interface]]
@@ -61,9 +78,14 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 
+* TODO mandos-dispatch
+  Listens for specified D-Bus signals and spawns shell commands with
+  arguments.
+
 * mandos-monitor
-** D-Bus mail loop w/ signal receiver
-** Snack/Newt client data displayer
+** D-Bus main loop w/ signal receiver
+** Urwid client data displayer
+*** Urwid scaffolding
 *** Client Widgets
 *** Properties popup
 

=== modified file 'debian/rules'
--- debian/rules	2009-10-25 19:06:56 +0000
+++ debian/rules	2009-11-01 00:10:28 +0000
@@ -15,6 +15,8 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
+# -pie is broken on the mips and mipsel architectures, see
+# <http://bugs.debian.org/526961>
 ifneq (,$(findstring :$(DEB_HOST_ARCH):,:mips:mipsel:))
   BROKEN_PIE := yes
   export BROKEN_PIE

=== modified file 'mandos'
--- mandos	2009-10-25 19:16:56 +0000
+++ mandos	2009-10-26 21:16:16 +0000
@@ -67,6 +67,8 @@
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
 import ctypes.util
+import xml.dom.minidom
+import inspect
 
 try:
     SO_BINDTODEVICE = socket.SO_BINDTODEVICE
@@ -174,7 +176,8 @@
                                     self.server.EntryGroupNew()),
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
             self.group.connect_to_signal('StateChanged',
-                                         self.entry_group_state_changed)
+                                         self
+                                         .entry_group_state_changed)
         logger.debug(u"Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -246,7 +249,7 @@
                                     to see if the client lives.
                                     'None' if no process is running.
     checker_initiator_tag: a gobject event source tag, or None
-    disable_initiator_tag:    - '' -
+    disable_initiator_tag: - '' -
     checker_callback_tag:  - '' -
     checker_command: string; External command which is run to check if
                      client lives.  %() expansions are done at
@@ -256,19 +259,19 @@
     """
     
     @staticmethod
-    def _datetime_to_milliseconds(dt):
-        "Convert a datetime.datetime() to milliseconds"
-        return ((dt.days * 24 * 60 * 60 * 1000)
-                + (dt.seconds * 1000)
-                + (dt.microseconds // 1000))
+    def _timedelta_to_milliseconds(td):
+        "Convert a datetime.timedelta() to milliseconds"
+        return ((td.days * 24 * 60 * 60 * 1000)
+                + (td.seconds * 1000)
+                + (td.microseconds // 1000))
     
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
-        return self._datetime_to_milliseconds(self.timeout)
+        return self._timedelta_to_milliseconds(self.timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
-        return self._datetime_to_milliseconds(self.interval)
+        return self._timedelta_to_milliseconds(self.interval)
     
     def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
@@ -289,7 +292,8 @@
         elif u"secfile" in config:
             with closing(open(os.path.expanduser
                               (os.path.expandvars
-                               (config[u"secfile"])))) as secfile:
+                               (config[u"secfile"])),
+                              "rb")) as secfile:
                 self.secret = secfile.read()
         else:
             raise TypeError(u"No secret or secfile for client %s"
@@ -395,8 +399,13 @@
         # is as it should be.
         
         # If a checker exists, make sure it is not a zombie
-        if self.checker is not None:
+        try:
             pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
+        except (AttributeError, OSError), error:
+            if (isinstance(error, OSError)
+                and error.errno != errno.ECHILD):
+                raise error
+        else:
             if pid:
                 logger.warning(u"Checker was a zombie")
                 gobject.source_remove(self.checker_callback_tag)
@@ -477,7 +486,187 @@
             return now < (self.last_checked_ok + self.timeout)
 
 
-class ClientDBus(Client, dbus.service.Object):
+def dbus_service_property(dbus_interface, signature=u"v",
+                          access=u"readwrite", byte_arrays=False):
+    """Decorators for marking methods of a DBusObjectWithProperties to
+    become properties on the D-Bus.
+    
+    The decorated method will be called with no arguments by "Get"
+    and with one argument by "Set".
+    
+    The parameters, where they are supported, are the same as
+    dbus.service.method, except there is only "signature", since the
+    type from Get() and the type sent to Set() is the same.
+    """
+    def decorator(func):
+        func._dbus_is_property = True
+        func._dbus_interface = dbus_interface
+        func._dbus_signature = signature
+        func._dbus_access = access
+        func._dbus_name = func.__name__
+        if func._dbus_name.endswith(u"_dbus_property"):
+            func._dbus_name = func._dbus_name[:-14]
+        func._dbus_get_args_options = {u'byte_arrays': byte_arrays }
+        return func
+    return decorator
+
+
+class DBusPropertyException(dbus.exceptions.DBusException):
+    """A base class for D-Bus property-related exceptions
+    """
+    def __unicode__(self):
+        return unicode(str(self))
+
+
+class DBusPropertyAccessException(DBusPropertyException):
+    """A property's access permissions disallows an operation.
+    """
+    pass
+
+
+class DBusPropertyNotFound(DBusPropertyException):
+    """An attempt was made to access a non-existing property.
+    """
+    pass
+
+
+class DBusObjectWithProperties(dbus.service.Object):
+    """A D-Bus object with properties.
+
+    Classes inheriting from this can use the dbus_service_property
+    decorator to expose methods as D-Bus properties.  It exposes the
+    standard Get(), Set(), and GetAll() methods on the D-Bus.
+    """
+    
+    @staticmethod
+    def _is_dbus_property(obj):
+        return getattr(obj, u"_dbus_is_property", False)
+    
+    def _get_all_dbus_properties(self):
+        """Returns a generator of (name, attribute) pairs
+        """
+        return ((prop._dbus_name, prop)
+                for name, prop in
+                inspect.getmembers(self, self._is_dbus_property))
+    
+    def _get_dbus_property(self, interface_name, property_name):
+        """Returns a bound method if one exists which is a D-Bus
+        property with the specified name and interface.
+        """
+        for name in (property_name,
+                     property_name + u"_dbus_property"):
+            prop = getattr(self, name, None)
+            if (prop is None
+                or not self._is_dbus_property(prop)
+                or prop._dbus_name != property_name
+                or (interface_name and prop._dbus_interface
+                    and interface_name != prop._dbus_interface)):
+                continue
+            return prop
+        # No such property
+        raise DBusPropertyNotFound(self.dbus_object_path + u":"
+                                   + interface_name + u"."
+                                   + property_name)
+    
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ss",
+                         out_signature=u"v")
+    def Get(self, interface_name, property_name):
+        """Standard D-Bus property Get() method, see D-Bus standard.
+        """
+        prop = self._get_dbus_property(interface_name, property_name)
+        if prop._dbus_access == u"write":
+            raise DBusPropertyAccessException(property_name)
+        value = prop()
+        if not hasattr(value, u"variant_level"):
+            return value
+        return type(value)(value, variant_level=value.variant_level+1)
+    
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"ssv")
+    def Set(self, interface_name, property_name, value):
+        """Standard D-Bus property Set() method, see D-Bus standard.
+        """
+        prop = self._get_dbus_property(interface_name, property_name)
+        if prop._dbus_access == u"read":
+            raise DBusPropertyAccessException(property_name)
+        if prop._dbus_get_args_options[u"byte_arrays"]:
+            value = dbus.ByteArray(''.join(unichr(byte)
+                                           for byte in value))
+        prop(value)
+    
+    @dbus.service.method(dbus.PROPERTIES_IFACE, in_signature=u"s",
+                         out_signature=u"a{sv}")
+    def GetAll(self, interface_name):
+        """Standard D-Bus property GetAll() method, see D-Bus
+        standard.
+
+        Note: Will not include properties with access="write".
+        """
+        all = {}
+        for name, prop in self._get_all_dbus_properties():
+            if (interface_name
+                and interface_name != prop._dbus_interface):
+                # Interface non-empty but did not match
+                continue
+            # Ignore write-only properties
+            if prop._dbus_access == u"write":
+                continue
+            value = prop()
+            if not hasattr(value, u"variant_level"):
+                all[name] = value
+                continue
+            all[name] = type(value)(value, variant_level=
+                                    value.variant_level+1)
+        return dbus.Dictionary(all, signature=u"sv")
+    
+    @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
+                         out_signature=u"s",
+                         path_keyword='object_path',
+                         connection_keyword='connection')
+    def Introspect(self, object_path, connection):
+        """Standard D-Bus method, overloaded to insert property tags.
+        """
+        xmlstring = dbus.service.Object.Introspect(self, object_path,
+                                                   connection)
+        try:
+            document = xml.dom.minidom.parseString(xmlstring)
+            def make_tag(document, name, prop):
+                e = document.createElement(u"property")
+                e.setAttribute(u"name", name)
+                e.setAttribute(u"type", prop._dbus_signature)
+                e.setAttribute(u"access", prop._dbus_access)
+                return e
+            for if_tag in document.getElementsByTagName(u"interface"):
+                for tag in (make_tag(document, name, prop)
+                            for name, prop
+                            in self._get_all_dbus_properties()
+                            if prop._dbus_interface
+                            == if_tag.getAttribute(u"name")):
+                    if_tag.appendChild(tag)
+                # Add the names to the return values for the
+                # "org.freedesktop.DBus.Properties" methods
+                if (if_tag.getAttribute(u"name")
+                    == u"org.freedesktop.DBus.Properties"):
+                    for cn in if_tag.getElementsByTagName(u"method"):
+                        if cn.getAttribute(u"name") == u"Get":
+                            for arg in cn.getElementsByTagName(u"arg"):
+                                if (arg.getAttribute(u"direction")
+                                    == u"out"):
+                                    arg.setAttribute(u"name", u"value")
+                        elif cn.getAttribute(u"name") == u"GetAll":
+                            for arg in cn.getElementsByTagName(u"arg"):
+                                if (arg.getAttribute(u"direction")
+                                    == u"out"):
+                                    arg.setAttribute(u"name", u"props")
+            xmlstring = document.toxml(u"utf-8")
+            document.unlink()
+        except (AttributeError, xml.dom.DOMException,
+                xml.parsers.expat.ExpatError), error:
+            logger.error(u"Failed to override Introspection method",
+                         error)
+        return xmlstring
+
+
+class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
     Attributes:
@@ -494,8 +683,8 @@
         self.dbus_object_path = (dbus.ObjectPath
                                  (u"/clients/"
                                   + self.name.replace(u".", u"_")))
-        dbus.service.Object.__init__(self, self.bus,
-                                     self.dbus_object_path)
+        DBusObjectWithProperties.__init__(self, self.bus,
+                                          self.dbus_object_path)
     
     @staticmethod
     def _datetime_to_dbus(dt, variant_level=0):
@@ -530,8 +719,8 @@
             self.remove_from_connection()
         except LookupError:
             pass
-        if hasattr(dbus.service.Object, u"__del__"):
-            dbus.service.Object.__del__(self, *args, **kwargs)
+        if hasattr(DBusObjectWithProperties, u"__del__"):
+            DBusObjectWithProperties.__del__(self, *args, **kwargs)
         Client.__del__(self, *args, **kwargs)
     
     def checker_callback(self, pid, condition, command,
@@ -611,63 +800,15 @@
         "D-Bus signal"
         pass
     
-    # GetAllProperties - method
-    @dbus.service.method(_interface, out_signature=u"a{sv}")
-    def GetAllProperties(self):
-        "D-Bus method"
-        return dbus.Dictionary({
-                dbus.String(u"name"):
-                    dbus.String(self.name, variant_level=1),
-                dbus.String(u"fingerprint"):
-                    dbus.String(self.fingerprint, variant_level=1),
-                dbus.String(u"host"):
-                    dbus.String(self.host, variant_level=1),
-                dbus.String(u"created"):
-                    self._datetime_to_dbus(self.created,
-                                           variant_level=1),
-                dbus.String(u"last_enabled"):
-                    (self._datetime_to_dbus(self.last_enabled,
-                                            variant_level=1)
-                     if self.last_enabled is not None
-                     else dbus.Boolean(False, variant_level=1)),
-                dbus.String(u"enabled"):
-                    dbus.Boolean(self.enabled, variant_level=1),
-                dbus.String(u"last_checked_ok"):
-                    (self._datetime_to_dbus(self.last_checked_ok,
-                                            variant_level=1)
-                     if self.last_checked_ok is not None
-                     else dbus.Boolean (False, variant_level=1)),
-                dbus.String(u"timeout"):
-                    dbus.UInt64(self.timeout_milliseconds(),
-                                variant_level=1),
-                dbus.String(u"interval"):
-                    dbus.UInt64(self.interval_milliseconds(),
-                                variant_level=1),
-                dbus.String(u"checker"):
-                    dbus.String(self.checker_command,
-                                variant_level=1),
-                dbus.String(u"checker_running"):
-                    dbus.Boolean(self.checker is not None,
-                                 variant_level=1),
-                dbus.String(u"object_path"):
-                    dbus.ObjectPath(self.dbus_object_path,
-                                    variant_level=1)
-                }, signature=u"sv")
-    
-    # IsStillValid - method
-    @dbus.service.method(_interface, out_signature=u"b")
-    def IsStillValid(self):
-        return self.still_valid()
-    
     # PropertyChanged - signal
     @dbus.service.signal(_interface, signature=u"sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
         pass
     
-    # ReceivedSecret - signal
+    # GotSecret - signal
     @dbus.service.signal(_interface)
-    def ReceivedSecret(self):
+    def GotSecret(self):
         "D-Bus signal"
         pass
     
@@ -677,50 +818,6 @@
         "D-Bus signal"
         pass
     
-    # SetChecker - method
-    @dbus.service.method(_interface, in_signature=u"s")
-    def SetChecker(self, checker):
-        "D-Bus setter method"
-        self.checker_command = checker
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"checker"),
-                             dbus.String(self.checker_command,
-                                         variant_level=1))
-    
-    # SetHost - method
-    @dbus.service.method(_interface, in_signature=u"s")
-    def SetHost(self, host):
-        "D-Bus setter method"
-        self.host = host
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"host"),
-                             dbus.String(self.host, variant_level=1))
-    
-    # SetInterval - method
-    @dbus.service.method(_interface, in_signature=u"t")
-    def SetInterval(self, milliseconds):
-        self.interval = datetime.timedelta(0, 0, 0, milliseconds)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"interval"),
-                             (dbus.UInt64(self.interval_milliseconds(),
-                                          variant_level=1)))
-    
-    # SetSecret - method
-    @dbus.service.method(_interface, in_signature=u"ay",
-                         byte_arrays=True)
-    def SetSecret(self, secret):
-        "D-Bus setter method"
-        self.secret = str(secret)
-    
-    # SetTimeout - method
-    @dbus.service.method(_interface, in_signature=u"t")
-    def SetTimeout(self, milliseconds):
-        self.timeout = datetime.timedelta(0, 0, 0, milliseconds)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String(u"timeout"),
-                             (dbus.UInt64(self.timeout_milliseconds(),
-                                          variant_level=1)))
-    
     # Enable - method
     @dbus.service.method(_interface)
     def Enable(self):
@@ -744,6 +841,142 @@
     def StopChecker(self):
         self.stop_checker()
     
+    # name - property
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    def name_dbus_property(self):
+        return dbus.String(self.name)
+    
+    # fingerprint - property
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    def fingerprint_dbus_property(self):
+        return dbus.String(self.fingerprint)
+    
+    # host - property
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
+    def host_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.String(self.host)
+        self.host = value
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String(u"host"),
+                             dbus.String(value, variant_level=1))
+    
+    # created - property
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    def created_dbus_property(self):
+        return dbus.String(self._datetime_to_dbus(self.created))
+    
+    # last_enabled - property
+    @dbus_service_property(_interface, signature=u"s", access=u"read")
+    def last_enabled_dbus_property(self):
+        if self.last_enabled is None:
+            return dbus.String(u"")
+        return dbus.String(self._datetime_to_dbus(self.last_enabled))
+    
+    # enabled - property
+    @dbus_service_property(_interface, signature=u"b",
+                           access=u"readwrite")
+    def enabled_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.Boolean(self.enabled)
+        if value:
+            self.enable()
+        else:
+            self.disable()
+    
+    # last_checked_ok - property
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
+    def last_checked_ok_dbus_property(self, value=None):
+        if value is not None:
+            self.checked_ok()
+            return
+        if self.last_checked_ok is None:
+            return dbus.String(u"")
+        return dbus.String(self._datetime_to_dbus(self
+                                                  .last_checked_ok))
+    
+    # timeout - property
+    @dbus_service_property(_interface, signature=u"t",
+                           access=u"readwrite")
+    def timeout_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.UInt64(self.timeout_milliseconds())
+        self.timeout = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String(u"timeout"),
+                             dbus.UInt64(value, variant_level=1))
+        if getattr(self, u"disable_initiator_tag", None) is None:
+            return
+        # Reschedule timeout
+        gobject.source_remove(self.disable_initiator_tag)
+        self.disable_initiator_tag = None
+        time_to_die = (self.
+                       _timedelta_to_milliseconds((self
+                                                   .last_checked_ok
+                                                   + self.timeout)
+                                                  - datetime.datetime
+                                                  .utcnow()))
+        if time_to_die <= 0:
+            # The timeout has passed
+            self.disable()
+        else:
+            self.disable_initiator_tag = (gobject.timeout_add
+                                          (time_to_die, self.disable))
+    
+    # interval - property
+    @dbus_service_property(_interface, signature=u"t",
+                           access=u"readwrite")
+    def interval_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.UInt64(self.interval_milliseconds())
+        self.interval = datetime.timedelta(0, 0, 0, value)
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String(u"interval"),
+                             dbus.UInt64(value, variant_level=1))
+        if getattr(self, u"checker_initiator_tag", None) is None:
+            return
+        # Reschedule checker run
+        gobject.source_remove(self.checker_initiator_tag)
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (value, self.start_checker))
+        self.start_checker()    # Start one now, too
+
+    # checker - property
+    @dbus_service_property(_interface, signature=u"s",
+                           access=u"readwrite")
+    def checker_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.String(self.checker_command)
+        self.checker_command = value
+        # Emit D-Bus signal
+        self.PropertyChanged(dbus.String(u"checker"),
+                             dbus.String(self.checker_command,
+                                         variant_level=1))
+    
+    # checker_running - property
+    @dbus_service_property(_interface, signature=u"b",
+                           access=u"readwrite")
+    def checker_running_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.Boolean(self.checker is not None)
+        if value:
+            self.start_checker()
+        else:
+            self.stop_checker()
+    
+    # object_path - property
+    @dbus_service_property(_interface, signature=u"o", access=u"read")
+    def object_path_dbus_property(self):
+        return self.dbus_object_path # is already a dbus.ObjectPath
+    
+    # secret = property
+    @dbus_service_property(_interface, signature=u"ay",
+                           access=u"write", byte_arrays=True)
+    def secret_dbus_property(self, value):
+        self.secret = str(value)
+    
     del _interface
 
 
@@ -983,9 +1216,6 @@
         clients:        set of Client objects
         gnutls_priority GnuTLS priority string
         use_dbus:       Boolean; to emit D-Bus signals or not
-        clients:        set of Client objects
-        gnutls_priority GnuTLS priority string
-        use_dbus:       Boolean; to emit D-Bus signals or not
     
     Assumes a gobject.MainLoop event loop.
     """
@@ -1071,7 +1301,7 @@
                     client.checked_ok()
                     if self.use_dbus:
                         # Emit D-Bus signal
-                        client.ReceivedSecret()
+                        client.GotSecret()
                     break
             else:
                 logger.error(u"Sending secret to unknown client %s",
@@ -1162,7 +1392,8 @@
         null = os.open(os.path.devnull, os.O_NOCTTY | os.O_RDWR)
         if not stat.S_ISCHR(os.fstat(null).st_mode):
             raise OSError(errno.ENODEV,
-                          u"/dev/null not a character device")
+                          u"%s not a character device"
+                          % os.path.devnull)
         os.dup2(null, sys.stdin.fileno())
         os.dup2(null, sys.stdout.fileno())
         os.dup2(null, sys.stderr.fileno())
@@ -1172,7 +1403,7 @@
 
 def main():
     
-    ######################################################################
+    ##################################################################
     # Parsing of options, both command line and config file
     
     parser = optparse.OptionParser(version = "%%prog %s" % version)
@@ -1196,8 +1427,8 @@
                       help=u"Directory to search for configuration"
                       u" files")
     parser.add_option("--no-dbus", action=u"store_false",
-                      dest=u"use_dbus",
-                      help=optparse.SUPPRESS_HELP) # XXX: Not done yet
+                      dest=u"use_dbus", help=u"Do not provide D-Bus"
+                      u" system bus interface")
     parser.add_option("--no-ipv6", action=u"store_false",
                       dest=u"use_ipv6", help=u"Do not use IPv6")
     options = parser.parse_args()[0]
@@ -1255,7 +1486,6 @@
     # For convenience
     debug = server_settings[u"debug"]
     use_dbus = server_settings[u"use_dbus"]
-    use_dbus = False            # XXX: Not done yet
     use_ipv6 = server_settings[u"use_ipv6"]
     
     if not debug:
@@ -1429,7 +1659,7 @@
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    ((c.dbus_object_path, c.GetAllProperties())
+                    ((c.dbus_object_path, c.GetAll(u""))
                      for c in tcp_server.clients),
                     signature=u"oa{sv}")
             
@@ -1455,7 +1685,7 @@
         if use_dbus:
             # Emit D-Bus signal
             mandos_dbus_service.ClientAdded(client.dbus_object_path,
-                                            client.GetAllProperties())
+                                            client.GetAll(u""))
         client.enable()
     
     tcp_server.enable()

=== modified file 'mandos-ctl'
--- mandos-ctl	2009-10-25 19:16:56 +0000
+++ mandos-ctl	2009-10-26 21:16:16 +0000
@@ -38,18 +38,20 @@
                              dbus_interface = server_interface)
 mandos_clients = mandos_serv.GetAllClientsWithProperties()
 
-def datetime_to_milliseconds(dt):
-    "Return the 'timeout' attribute in milliseconds"
-    return ((dt.days * 24 * 60 * 60 * 1000)
-            + (dt.seconds * 1000)
-            + (dt.microseconds // 1000))
+def timedelta_to_milliseconds(td):
+    "Convert a datetime.timedelta object to milliseconds"
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return "%s%02d:%02d:%02d" % (("%dT" % td.days) if td.days else "", # days
-                           td.seconds // 3600,        # hours
-                           (td.seconds % 3600) // 60, # minutes
-                           (td.seconds % 60))         # seconds
+    return (u"%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
+            % { "days": "%dT" % td.days if td.days else "",
+                "hours": td.seconds // 3600,
+                "minutes": (td.seconds % 3600) // 60,
+                "seconds": td.seconds % 60,
+                })
 
 
 def string_to_delta(interval):
@@ -96,16 +98,18 @@
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
             return u"Yes" if value else u"No"
-        if keyword in ("timeout", "interval"):
+        if keyword in (u"timeout", u"interval"):
             return milliseconds_to_string(value)
         return unicode(value)
     
+    # Create format string to print table rows
     format_string = u' '.join(u'%%-%ds' %
                               max(len(tablewords[key]),
                                   max(len(valuetostring(client[key], key))
                                       for client in
                                       clients))
                               for key in keywords)
+    # Print header line
     print format_string % tuple(tablewords[key] for key in keywords)
     for client in clients:
         print format_string % tuple(valuetostring(client[key], key)
@@ -146,9 +150,7 @@
     for path, client in mandos_clients.iteritems():
         if client['name'] == name:
             client_objc = bus.get_object(busname, path)
-            clients.append(dbus.Interface(client_objc,
-                                          dbus_interface
-                                          = client_interface))
+            clients.append(client_objc)
             break
     else:
         print >> sys.stderr, "Client not found on server: %r" % name
@@ -167,27 +169,37 @@
     if options.remove:
         mandos_serv.RemoveClient(client.__dbus_object_path__)
     if options.enable:
-        client.Enable()
+        client.Enable(dbus_interface=client_interface)
     if options.disable:
-        client.Disable()
+        client.Disable(dbus_interface=client_interface)
     if options.bump_timeout:
-        client.BumpTimeout()
+        client.CheckedOK(dbus_interface=client_interface)
     if options.start_checker:
-        client.StartChecker()
+        client.StartChecker(dbus_interface=client_interface)
     if options.stop_checker:
-        client.StopChecker()
+        client.StopChecker(dbus_interface=client_interface)
     if options.is_valid:
-        sys.exit(0 if client.IsStillValid() else 1)
+        sys.exit(0 if client.Get(client_interface,
+                                 u"enabled",
+                                 dbus_interface=dbus.PROPERTIES_IFACE)
+                 else 1)
     if options.checker:
-        client.SetChecker(options.checker)
+        client.Set(client_interface, u"checker", options.checker,
+                   dbus_interface=dbus.PROPERTIES_IFACE)
     if options.host:
-        client.SetHost(options.host)
+        client.Set(client_interface, u"host", options.host,
+                   dbus_interface=dbus.PROPERTIES_IFACE)
     if options.interval:
-        client.SetInterval(datetime_to_milliseconds
-                           (string_to_delta(options.interval)))
+        client.Set(client_interface, u"interval",
+                   timedelta_to_milliseconds
+                   (string_to_delta(options.interval)),
+                   dbus_interface=dbus.PROPERTIES_IFACE)
     if options.timeout:
-        client.SetTimeout(datetime_to_milliseconds
-                          (string_to_delta(options.timeout)))
+        client.Set(client_interface, u"timeout",
+                   timedelta_to_milliseconds(string_to_delta
+                                             (options.timeout)),
+                   dbus_interface=dbus.PROPERTIES_IFACE)
     if options.secret:
-        client.SetSecret(dbus.ByteArray(open(options.secret, 'rb').read()))
-    
+        client.Set(client_interface, u"secret",
+                   dbus.ByteArray(open(options.secret, u'rb').read()),
+                   dbus_interface=dbus.PROPERTIES_IFACE)

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-10-25 19:16:56 +0000
+++ mandos-keygen	2009-10-26 21:16:16 +0000
@@ -217,12 +217,27 @@
 	%commit
 	EOF
     
+    if tty --quiet; then
+	cat <<-EOF
+	Note: Due to entropy requirements, key generation could take
+	anything from a few minutes to SEVERAL HOURS.  Please be
+	patient and/or supply the system with more entropy if needed.
+	EOF
+	echo -n "Started: "
+	date
+    fi
+    
     # Generate a new key in the key rings
     gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
 	--homedir "$RINGDIR" --trust-model always \
 	--gen-key "$BATCHFILE"
     rm --force "$BATCHFILE"
     
+    if tty --quiet; then
+	echo -n "Finished: "
+	date
+    fi
+    
     # Backup any old key files
     if cp --backup=numbered --force "$SECKEYFILE" "$SECKEYFILE" \
 	2>/dev/null; then
@@ -263,7 +278,7 @@
     
     # Get fingerprint of key
     FINGERPRINT="`gpg --quiet --batch --no-tty --no-options \
-	--enable-dsa2 --homedir \"$RINGDIR\" --trust-model always \
+	--enable-dsa2 --homedir '"'$RINGDIR'"' --trust-model always \
 	--fingerprint --with-colons \
 	| sed --quiet \
 	--expression='/^fpr:/{s/^fpr:.*:\\([0-9A-Z]*\\):\$/\\1/p;q}'`"

=== modified file 'mandos.xml'
--- mandos.xml	2009-09-17 11:47:22 +0000
+++ mandos.xml	2009-09-17 01:21:27 +0000
@@ -86,6 +86,8 @@
       <sbr/>
       <arg><option>--debug</option></arg>
       <sbr/>
+      <arg><option>--no-dbus</option></arg>
+      <sbr/>
       <arg><option>--no-ipv6</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
@@ -233,6 +235,16 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>--no-dbus</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="dbus"/>
+	  <para>
+	    See also <xref linkend="dbus_interface"/>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>--no-ipv6</option></term>
 	<listitem>
 	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
@@ -336,6 +348,16 @@
     </para>
   </refsect1>
   
+  <refsect1 id="dbus_interface">
+    <title>D-BUS INTERFACE</title>
+    <para>
+      The server will by default provide a D-Bus system bus interface.
+      This interface will only be accessible by the root user or a
+      Mandos-specific user, if such a user exists.
+      <!-- XXX -->
+    </para>
+  </refsect1>
+  
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2009-09-10 06:28:14 +0000
+++ plugin-runner.c	2009-11-01 00:10:28 +0000
@@ -23,14 +23,14 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
-				   asprintf() */
+				   asprintf(), O_CLOEXEC */
 #include <stddef.h>		/* size_t, NULL */
-#include <stdlib.h>		/* malloc(), exit(), EXIT_FAILURE,
-				   EXIT_SUCCESS, realloc() */
+#include <stdlib.h>		/* malloc(), exit(), EXIT_SUCCESS,
+				   realloc() */
 #include <stdbool.h>		/* bool, true, false */
 #include <stdio.h>		/* perror, fileno(), fprintf(),
 				   stderr, STDOUT_FILENO */
-#include <sys/types.h>	        /* DIR, opendir(), stat(), struct
+#include <sys/types.h>	        /* DIR, fdopendir(), stat(), struct
 				   stat, waitpid(), WIFEXITED(),
 				   WEXITSTATUS(), wait(), pid_t,
 				   uid_t, gid_t, getuid(), getgid(),
@@ -42,7 +42,7 @@
 				   WCOREDUMP() */
 #include <sys/stat.h>		/* struct stat, stat(), S_ISREG() */
 #include <iso646.h>		/* and, or, not */
-#include <dirent.h>		/* DIR, struct dirent, opendir(),
+#include <dirent.h>		/* DIR, struct dirent, fdopendir(),
 				   readdir(), closedir(), dirfd() */
 #include <unistd.h>		/* struct stat, stat(), S_ISREG(),
 				   fcntl(), setuid(), setgid(),
@@ -68,6 +68,8 @@
 				*/
 #include <errno.h>		/* errno, EBADF */
 #include <inttypes.h>		/* intmax_t, PRIdMAX, strtoimax() */
+#include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_IOERR,
+				   EX_CONFIG, EX_UNAVAILABLE, EX_OK */
 
 #define BUFFER_SIZE 256
 
@@ -102,7 +104,7 @@
 /* Gets an existing plugin based on name,
    or if none is found, creates a new one */
 static plugin *getplugin(char *name){
-  /* Check for exiting plugin with that name */
+  /* Check for existing plugin with that name */
   for(plugin *p = plugin_list; p != NULL; p = p->next){
     if((p->name == name)
        or (p->name and name and (strcmp(p->name, name) == 0))){
@@ -123,7 +125,9 @@
       copy_name = strdup(name);
     } while(copy_name == NULL and errno == EINTR);
     if(copy_name == NULL){
+      int e = errno;
       free(new_plugin);
+      errno = e;
       return NULL;
     }
   }
@@ -137,8 +141,10 @@
     new_plugin->argv = malloc(sizeof(char *) * 2);
   } while(new_plugin->argv == NULL and errno == EINTR);
   if(new_plugin->argv == NULL){
+    int e = errno;
     free(copy_name);
     free(new_plugin);
+    errno = e;
     return NULL;
   }
   new_plugin->argv[0] = copy_name;
@@ -148,9 +154,11 @@
     new_plugin->environ = malloc(sizeof(char *));
   } while(new_plugin->environ == NULL and errno == EINTR);
   if(new_plugin->environ == NULL){
+    int e = errno;
     free(copy_name);
     free(new_plugin->argv);
     free(new_plugin);
+    errno = e;
     return NULL;
   }
   new_plugin->environ[0] = NULL;
@@ -350,13 +358,13 @@
   ret = sigaddset(&sigchld_action.sa_mask, SIGCHLD);
   if(ret == -1){
     perror("sigaddset");
-    exitstatus = EXIT_FAILURE;
+    exitstatus = EX_OSERR;
     goto fallback;
   }
   ret = sigaction(SIGCHLD, &sigchld_action, &old_sigchld_action);
   if(ret == -1){
     perror("sigaction");
-    exitstatus = EXIT_FAILURE;
+    exitstatus = EX_OSERR;
     goto fallback;
   }
   
@@ -394,119 +402,137 @@
       .doc = "Group ID the plugins will run as", .group = 3 },
     { .name = "debug", .key = 132,
       .doc = "Debug mode", .group = 4 },
+    /*
+     * These reproduce what we would get without ARGP_NO_HELP
+     */
+    { .name = "help", .key = '?',
+      .doc = "Give this help list", .group = -1 },
+    { .name = "usage", .key = -3,
+      .doc = "Give a short usage message", .group = -1 },
+    { .name = "version", .key = 'V',
+      .doc = "Print program version", .group = -1 },
     { .name = NULL }
   };
   
-  error_t parse_opt(int key, char *arg, __attribute__((unused))
-		    struct argp_state *state){
+  error_t parse_opt(int key, char *arg, struct argp_state *state){
+    errno = 0;
     switch(key){
       char *tmp;
       intmax_t tmpmax;
     case 'g': 			/* --global-options */
-      if(arg != NULL){
+      {
 	char *plugin_option;
 	while((plugin_option = strsep(&arg, ",")) != NULL){
-	  if(plugin_option[0] == '\0'){
-	    continue;
-	  }
 	  if(not add_argument(getplugin(NULL), plugin_option)){
-	    perror("add_argument");
-	    return ARGP_ERR_UNKNOWN;
+	    break;
 	  }
 	}
       }
       break;
     case 'G':			/* --global-env */
-      if(arg == NULL){
-	break;
-      }
-      if(not add_environment(getplugin(NULL), arg, true)){
-	perror("add_environment");
-      }
+      add_environment(getplugin(NULL), arg, true);
       break;
     case 'o':			/* --options-for */
-      if(arg != NULL){
-	char *plugin_name = strsep(&arg, ":");
-	if(plugin_name[0] == '\0'){
-	  break;
-	}
-	char *plugin_option;
-	while((plugin_option = strsep(&arg, ",")) != NULL){
-	  if(not add_argument(getplugin(plugin_name), plugin_option)){
-	    perror("add_argument");
-	    return ARGP_ERR_UNKNOWN;
+      {
+	char *option_list = strchr(arg, ':');
+	if(option_list == NULL){
+	  argp_error(state, "No colon in \"%s\"", arg);
+	  errno = EINVAL;
+	  break;
+	}
+	*option_list = '\0';
+	option_list++;
+	if(arg[0] == '\0'){
+	  argp_error(state, "Empty plugin name");
+	  errno = EINVAL;
+	  break;
+	}
+	char *option;
+	while((option = strsep(&option_list, ",")) != NULL){
+	  if(not add_argument(getplugin(arg), option)){
+	    break;
 	  }
 	}
       }
       break;
     case 'E':			/* --env-for */
-      if(arg == NULL){
-	break;
-      }
       {
 	char *envdef = strchr(arg, ':');
 	if(envdef == NULL){
+	  argp_error(state, "No colon in \"%s\"", arg);
+	  errno = EINVAL;
 	  break;
 	}
 	*envdef = '\0';
-	if(not add_environment(getplugin(arg), envdef+1, true)){
-	  perror("add_environment");
+	envdef++;
+	if(arg[0] == '\0'){
+	  argp_error(state, "Empty plugin name");
+	  errno = EINVAL;
+	  break;
 	}
+	add_environment(getplugin(arg), envdef, true);
       }
       break;
     case 'd':			/* --disable */
-      if(arg != NULL){
+      {
 	plugin *p = getplugin(arg);
-	if(p == NULL){
-	  return ARGP_ERR_UNKNOWN;
+	if(p != NULL){
+	  p->disabled = true;
 	}
-	p->disabled = true;
       }
       break;
     case 'e':			/* --enable */
-      if(arg != NULL){
+      {
 	plugin *p = getplugin(arg);
-	if(p == NULL){
-	  return ARGP_ERR_UNKNOWN;
+	if(p != NULL){
+	  p->disabled = false;
 	}
-	p->disabled = false;
       }
       break;
     case 128:			/* --plugin-dir */
       free(plugindir);
       plugindir = strdup(arg);
-      if(plugindir == NULL){
-	perror("strdup");
-      }
       break;
     case 129:			/* --config-file */
       /* This is already done by parse_opt_config_file() */
       break;
     case 130:			/* --userid */
-      errno = 0;
       tmpmax = strtoimax(arg, &tmp, 10);
       if(errno != 0 or tmp == arg or *tmp != '\0'
 	 or tmpmax != (uid_t)tmpmax){
-	fprintf(stderr, "Bad user ID number: \"%s\", using %"
-		PRIdMAX "\n", arg, (intmax_t)uid);
-      } else {
-	uid = (uid_t)tmpmax;
+	argp_error(state, "Bad user ID number: \"%s\", using %"
+		   PRIdMAX, arg, (intmax_t)uid);
+	break;
       }
+      uid = (uid_t)tmpmax;
       break;
     case 131:			/* --groupid */
-      errno = 0;
       tmpmax = strtoimax(arg, &tmp, 10);
       if(errno != 0 or tmp == arg or *tmp != '\0'
 	 or tmpmax != (gid_t)tmpmax){
-	fprintf(stderr, "Bad group ID number: \"%s\", using %"
-		PRIdMAX "\n", arg, (intmax_t)gid);
-      } else {
-	gid = (gid_t)tmpmax;
+	argp_error(state, "Bad group ID number: \"%s\", using %"
+		   PRIdMAX, arg, (intmax_t)gid);
+	break;
       }
+      gid = (gid_t)tmpmax;
       break;
     case 132:			/* --debug */
       debug = true;
       break;
+      /*
+       * These reproduce what we would get without ARGP_NO_HELP
+       */
+    case '?':			/* --help */
+      state->flags &= ~(unsigned int)ARGP_NO_EXIT; /* force exit */
+      argp_state_help(state, state->out_stream, ARGP_HELP_STD_HELP);
+    case -3:			/* --usage */
+      state->flags &= ~(unsigned int)ARGP_NO_EXIT; /* force exit */
+      argp_state_help(state, state->out_stream,
+		      ARGP_HELP_USAGE | ARGP_HELP_EXIT_OK);
+    case 'V':			/* --version */
+      fprintf(state->out_stream, "%s\n", argp_program_version);
+      exit(EXIT_SUCCESS);
+      break;
 /*
  * When adding more options before this line, remember to also add a
  * "case" to the "parse_opt_config_file" function below.
@@ -515,16 +541,13 @@
       /* Cryptsetup always passes an argument, which is an empty
 	 string if "none" was specified in /etc/crypttab.  So if
 	 argument was empty, we ignore it silently. */
-      if(arg[0] != '\0'){
-	fprintf(stderr, "Ignoring unknown argument \"%s\"\n", arg);
+      if(arg[0] == '\0'){
+	break;
       }
-      break;
-    case ARGP_KEY_END:
-      break;
     default:
       return ARGP_ERR_UNKNOWN;
     }
-    return 0;
+    return errno;		/* Set to 0 at start */
   }
   
   /* This option parser is the same as parse_opt() above, except it
@@ -532,6 +555,7 @@
   error_t parse_opt_config_file(int key, char *arg,
 				__attribute__((unused))
 				struct argp_state *state){
+    errno = 0;
     switch(key){
     case 'g': 			/* --global-options */
     case 'G':			/* --global-env */
@@ -544,20 +568,19 @@
     case 129:			/* --config-file */
       free(argfile);
       argfile = strdup(arg);
-      if(argfile == NULL){
-	perror("strdup");
-      }
       break;
     case 130:			/* --userid */
     case 131:			/* --groupid */
     case 132:			/* --debug */
+    case '?':			/* --help */
+    case -3:			/* --usage */
+    case 'V':			/* --version */
     case ARGP_KEY_ARG:
-    case ARGP_KEY_END:
       break;
     default:
       return ARGP_ERR_UNKNOWN;
     }
-    return 0;
+    return errno;
   }
   
   struct argp argp = { .options = options,
@@ -567,10 +590,20 @@
   
   /* Parse using parse_opt_config_file() in order to get the custom
      config file location, if any. */
-  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
-  if(ret == ARGP_ERR_UNKNOWN){
-    fprintf(stderr, "Unknown error while parsing arguments\n");
-    exitstatus = EXIT_FAILURE;
+  ret = argp_parse(&argp, argc, argv,
+		   ARGP_IN_ORDER | ARGP_NO_EXIT | ARGP_NO_HELP,
+		   NULL, NULL);
+  switch(ret){
+  case 0:
+    break;
+  case ENOMEM:
+  default:
+    errno = ret;
+    perror("argp_parse");
+    exitstatus = EX_OSERR;
+    goto fallback;
+  case EINVAL:
+    exitstatus = EX_USAGE;
     goto fallback;
   }
   
@@ -594,7 +627,7 @@
     custom_argv = malloc(sizeof(char*) * 2);
     if(custom_argv == NULL){
       perror("malloc");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     custom_argv[0] = argv[0];
@@ -617,7 +650,7 @@
 	new_arg = strdup(p);
 	if(new_arg == NULL){
 	  perror("strdup");
-	  exitstatus = EXIT_FAILURE;
+	  exitstatus = EX_OSERR;
 	  free(org_line);
 	  goto fallback;
 	}
@@ -627,7 +660,7 @@
 			      * ((unsigned int) custom_argc + 1));
 	if(custom_argv == NULL){
 	  perror("realloc");
-	  exitstatus = EXIT_FAILURE;
+	  exitstatus = EX_OSERR;
 	  free(org_line);
 	  goto fallback;
 	}
@@ -640,7 +673,7 @@
     } while(ret == EOF and errno == EINTR);
     if(ret == EOF){
       perror("fclose");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_IOERR;
       goto fallback;
     }
     free(org_line);
@@ -649,28 +682,47 @@
        not affect opening plugins */
     if(errno == EMFILE or errno == ENFILE or errno == ENOMEM){
       perror("fopen");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_IOERR;
       goto fallback;
     }
   }
-  /* If there was any arguments from configuration file,
-     pass them to parser as command arguments */
+  /* If there were any arguments from the configuration file, pass
+     them to parser as command line arguments */
   if(custom_argv != NULL){
-    ret = argp_parse(&argp, custom_argc, custom_argv, ARGP_IN_ORDER,
-		     0, NULL);
-    if(ret == ARGP_ERR_UNKNOWN){
-      fprintf(stderr, "Unknown error while parsing arguments\n");
-      exitstatus = EXIT_FAILURE;
+    ret = argp_parse(&argp, custom_argc, custom_argv,
+		     ARGP_IN_ORDER | ARGP_NO_EXIT | ARGP_NO_HELP,
+		     NULL, NULL);
+    switch(ret){
+    case 0:
+      break;
+    case ENOMEM:
+    default:
+      errno = ret;
+      perror("argp_parse");
+      exitstatus = EX_OSERR;
+      goto fallback;
+    case EINVAL:
+      exitstatus = EX_CONFIG;
       goto fallback;
     }
   }
   
   /* Parse actual command line arguments, to let them override the
      config file */
-  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
-  if(ret == ARGP_ERR_UNKNOWN){
-    fprintf(stderr, "Unknown error while parsing arguments\n");
-    exitstatus = EXIT_FAILURE;
+  ret = argp_parse(&argp, argc, argv,
+		   ARGP_IN_ORDER | ARGP_NO_EXIT | ARGP_NO_HELP,
+		   NULL, NULL);
+  switch(ret){
+  case 0:
+    break;
+  case ENOMEM:
+  default:
+    errno = ret;
+    perror("argp_parse");
+    exitstatus = EX_OSERR;
+    goto fallback;
+  case EINVAL:
+    exitstatus = EX_USAGE;
     goto fallback;
   }
   
@@ -698,28 +750,49 @@
     perror("setuid");
   }
   
-  if(plugindir == NULL){
-    dir = opendir(PDIR);
-  } else {
-    dir = opendir(plugindir);
-  }
-  
-  if(dir == NULL){
-    perror("Could not open plugin dir");
-    exitstatus = EXIT_FAILURE;
-    goto fallback;
-  }
-  
-  /* Set the FD_CLOEXEC flag on the directory, if possible */
+  /* Open plugin directory with close_on_exec flag */
   {
-    int dir_fd = dirfd(dir);
-    if(dir_fd >= 0){
-      ret = set_cloexec_flag(dir_fd);
-      if(ret < 0){
-	perror("set_cloexec_flag");
-	exitstatus = EXIT_FAILURE;
-	goto fallback;
-      }
+    int dir_fd = -1;
+    if(plugindir == NULL){
+      dir_fd = open(PDIR, O_RDONLY |
+#ifdef O_CLOEXEC
+		    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		    0
+#endif	/* not O_CLOEXEC */
+		    );
+    } else {
+      dir_fd = open(plugindir, O_RDONLY |
+#ifdef O_CLOEXEC
+		    O_CLOEXEC
+#else  /* not O_CLOEXEC */
+		    0
+#endif	/* not O_CLOEXEC */
+		    );
+    }
+    if(dir_fd == -1){
+      perror("Could not open plugin dir");
+      exitstatus = EX_UNAVAILABLE;
+      goto fallback;
+    }
+    
+#ifndef O_CLOEXEC
+  /* Set the FD_CLOEXEC flag on the directory */
+    ret = set_cloexec_flag(dir_fd);
+    if(ret < 0){
+      perror("set_cloexec_flag");
+      TEMP_FAILURE_RETRY(close(dir_fd));
+      exitstatus = EX_OSERR;
+      goto fallback;
+    }
+#endif	/* O_CLOEXEC */
+    
+    dir = fdopendir(dir_fd);
+    if(dir == NULL){
+      perror("Could not open plugin dir");
+      TEMP_FAILURE_RETRY(close(dir_fd));
+      exitstatus = EX_OSERR;
+      goto fallback;
     }
   }
   
@@ -735,7 +808,7 @@
     if(dirst == NULL){
       if(errno == EBADF){
 	perror("readdir");
-	exitstatus = EXIT_FAILURE;
+	exitstatus = EX_IOERR;
 	goto fallback;
       }
       break;
@@ -865,20 +938,20 @@
     ret = (int)TEMP_FAILURE_RETRY(pipe(pipefd));
     if(ret == -1){
       perror("pipe");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     /* Ask OS to automatic close the pipe on exec */
     ret = set_cloexec_flag(pipefd[0]);
     if(ret < 0){
       perror("set_cloexec_flag");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     ret = set_cloexec_flag(pipefd[1]);
     if(ret < 0){
       perror("set_cloexec_flag");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     /* Block SIGCHLD until process is safely in process list */
@@ -887,7 +960,7 @@
 					      NULL));
     if(ret < 0){
       perror("sigprocmask");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     /* Starting a new process to be watched */
@@ -897,7 +970,7 @@
     } while(pid == -1 and errno == EINTR);
     if(pid == -1){
       perror("fork");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     if(pid == 0){
@@ -905,18 +978,18 @@
       ret = sigaction(SIGCHLD, &old_sigchld_action, NULL);
       if(ret < 0){
 	perror("sigaction");
-	_exit(EXIT_FAILURE);
+	_exit(EX_OSERR);
       }
       ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
       if(ret < 0){
 	perror("sigprocmask");
-	_exit(EXIT_FAILURE);
+	_exit(EX_OSERR);
       }
       
       ret = dup2(pipefd[1], STDOUT_FILENO); /* replace our stdout */
       if(ret == -1){
 	perror("dup2");
-	_exit(EXIT_FAILURE);
+	_exit(EX_OSERR);
       }
       
       if(dirfd(dir) < 0){
@@ -927,12 +1000,12 @@
       if(p->environ[0] == NULL){
 	if(execv(filename, p->argv) < 0){
 	  perror("execv");
-	  _exit(EXIT_FAILURE);
+	  _exit(EX_OSERR);
 	}
       } else {
 	if(execve(filename, p->argv, p->environ) < 0){
 	  perror("execve");
-	  _exit(EXIT_FAILURE);
+	  _exit(EX_OSERR);
 	}
       }
       /* no return */
@@ -950,7 +1023,7 @@
       if(ret < 0){
         perror("sigprocmask");
       }
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     
@@ -964,11 +1037,12 @@
 					      NULL));
     if(ret < 0){
       perror("sigprocmask");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     
-    FD_SET(new_plugin->fd, &rfds_all);
+    FD_SET(new_plugin->fd, &rfds_all); /* Spurious warning from
+					  -Wconversion */
     
     if(maxfd < new_plugin->fd){
       maxfd = new_plugin->fd;
@@ -996,7 +1070,7 @@
     int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
     if(select_ret == -1 and errno != EINTR){
       perror("select");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_OSERR;
       goto fallback;
     }
     /* OK, now either a process completed, or something can be read
@@ -1028,7 +1102,8 @@
 	  }
 	  
 	  /* Remove the plugin */
-	  FD_CLR(proc->fd, &rfds_all);
+	  FD_CLR(proc->fd, &rfds_all); /* Spurious warning from
+					  -Wconversion */
 	  
 	  /* Block signal while modifying process_list */
 	  ret = (int)TEMP_FAILURE_RETRY(sigprocmask
@@ -1037,7 +1112,7 @@
 					 NULL));
 	  if(ret < 0){
 	    perror("sigprocmask");
-	    exitstatus = EXIT_FAILURE;
+	    exitstatus = EX_OSERR;
 	    goto fallback;
 	  }
 	  
@@ -1051,7 +1126,7 @@
 				   &sigchld_action.sa_mask, NULL)));
 	  if(ret < 0){
 	    perror("sigprocmask");
-	    exitstatus = EXIT_FAILURE;
+	    exitstatus = EX_OSERR;
 	    goto fallback;
 	  }
 	  
@@ -1068,13 +1143,15 @@
 				       proc->buffer_length);
 	if(not bret){
 	  perror("print_out_password");
-	  exitstatus = EXIT_FAILURE;
+	  exitstatus = EX_IOERR;
 	}
 	goto fallback;
       }
       
       /* This process has not completed.  Does it have any output? */
-      if(proc->eof or not FD_ISSET(proc->fd, &rfds)){
+      if(proc->eof or not FD_ISSET(proc->fd, &rfds)){ /* Spurious
+							 warning from
+							 -Wconversion */
 	/* This process had nothing to say at this time */
 	proc = proc->next;
 	continue;
@@ -1085,7 +1162,7 @@
 			       + (size_t) BUFFER_SIZE);
 	if(proc->buffer == NULL){
 	  perror("malloc");
-	  exitstatus = EXIT_FAILURE;
+	  exitstatus = EX_OSERR;
 	  goto fallback;
 	}
 	proc->buffer_size += BUFFER_SIZE;
@@ -1112,7 +1189,8 @@
   
  fallback:
   
-  if(plugin_list == NULL or exitstatus != EXIT_SUCCESS){
+  if(plugin_list == NULL or (exitstatus != EXIT_SUCCESS
+			     and exitstatus != EX_OK)){
     /* Fallback if all plugins failed, none are found or an error
        occured */
     bool bret;
@@ -1127,7 +1205,7 @@
     bret = print_out_password(passwordbuffer, len);
     if(not bret){
       perror("print_out_password");
-      exitstatus = EXIT_FAILURE;
+      exitstatus = EX_IOERR;
     }
   }
   
@@ -1135,7 +1213,7 @@
   ret = sigaction(SIGCHLD, &old_sigchld_action, NULL);
   if(ret == -1){
     perror("sigaction");
-    exitstatus = EXIT_FAILURE;
+    exitstatus = EX_OSERR;
   }
   
   if(custom_argv != NULL){

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2009-09-16 23:28:39 +0000
+++ plugins.d/askpass-fifo.c	2009-10-18 16:09:05 +0000
@@ -26,13 +26,19 @@
 #include <sys/types.h>		/* ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
-#include <errno.h>		/* errno, EEXIST */
+#include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
+				   ENAMETOOLONG, ENOSPC, EROFS,
+				   ENOENT, EEXIST, EFAULT, EMFILE,
+				   ENFILE, ENOMEM, EBADF, EINVAL, EIO,
+				   EISDIR, EFBIG */
 #include <stdio.h>		/* perror() */
 #include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(),
 				   realloc(), EXIT_SUCCESS */
 #include <fcntl.h>		/* open(), O_RDONLY */
 #include <unistd.h>		/* read(), close(), write(),
 				   STDOUT_FILENO */
+#include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
+				   EX_UNAVAILABLE, EX_IOERR */
 
 
 int main(__attribute__((unused))int argc,
@@ -43,16 +49,46 @@
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
-  if(ret == -1 and errno != EEXIST){
+  if(ret == -1){
+    int e = errno;
     perror("mkfifo");
-    return EXIT_FAILURE;
+    switch(e){
+    case EACCES:
+    case ENOTDIR:
+    case ELOOP:
+      return EX_OSFILE;
+    case ENAMETOOLONG:
+    case ENOSPC:
+    case EROFS:
+    default:
+      return EX_OSERR;
+    case ENOENT:
+      return EX_UNAVAILABLE;	/* no "/lib/cryptsetup"? */
+    case EEXIST:
+      break;			/* not an error */
+    }
   }
   
   /* Open FIFO */
   int fifo_fd = open(passfifo, O_RDONLY);
   if(fifo_fd == -1){
+    int e = errno;
     perror("open");
-    return EXIT_FAILURE;
+    switch(e){
+    case EACCES:
+    case ENOENT:
+    case EFAULT:
+      return EX_UNAVAILABLE;
+    case ENAMETOOLONG:
+    case EMFILE:
+    case ENFILE:
+    case ENOMEM:
+    default:
+      return EX_OSERR;
+    case ENOTDIR:
+    case ELOOP:
+      return EX_OSFILE;
+    }
   }
   
   /* Read from FIFO */
@@ -67,16 +103,28 @@
 	if(tmp == NULL){
 	  perror("realloc");
 	  free(buf);
-	  return EXIT_FAILURE;
+	  return EX_OSERR;
 	}
 	buf = tmp;
 	buf_allocated += blocksize;
       }
       sret = read(fifo_fd, buf + buf_len, buf_allocated - buf_len);
       if(sret == -1){
+	int e = errno;
+	free(buf);
+	errno = e;
 	perror("read");
-	free(buf);
-	return EXIT_FAILURE;
+	switch(e){
+	case EBADF:
+	case EFAULT:
+	case EINVAL:
+	default:
+	  return EX_OSERR;
+	case EIO:
+	  return EX_IOERR;
+	case EISDIR:
+	  return EX_UNAVAILABLE;
+	}
       }
       buf_len += (size_t)sret;
     } while(sret != 0);
@@ -90,13 +138,37 @@
   while(written < buf_len){
     sret = write(STDOUT_FILENO, buf + written, buf_len - written);
     if(sret == -1){
+      int e = errno;
+      free(buf);
+      errno = e;
       perror("write");
-      free(buf);
-      return EXIT_FAILURE;
+      switch(e){
+      case EBADF:
+      case EFAULT:
+      case EINVAL:
+	return EX_OSFILE;
+      case EFBIG:
+      case EIO:
+      case ENOSPC:
+      default:
+	return EX_IOERR;
+      }
     }
     written += (size_t)sret;
   }
   free(buf);
   
+  ret = close(STDOUT_FILENO);
+  if(ret == -1){
+    int e = errno;
+    perror("close");
+    switch(e){
+    case EBADF:
+      return EX_OSFILE;
+    case EIO:
+    default:
+      return EX_IOERR;
+    }
+  }
   return EXIT_SUCCESS;
 }

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-08-11 20:06:18 +0000
+++ plugins.d/mandos-client.c	2009-11-01 00:10:28 +0000
@@ -43,8 +43,8 @@
 				   stdout, ferror(), remove() */
 #include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <stdlib.h> 		/* free(), EXIT_SUCCESS, EXIT_FAILURE,
-				   srand(), strtof(), abort() */
+#include <stdlib.h> 		/* free(), EXIT_SUCCESS, srand(),
+				   strtof(), abort() */
 #include <stdbool.h>		/* bool, false, true */
 #include <string.h>		/* memset(), strcmp(), strlen(),
 				   strerror(), asprintf(), strcpy() */
@@ -82,6 +82,8 @@
 #include <signal.h>		/* sigemptyset(), sigaddset(),
 				   sigaction(), SIGTERM, sig_atomic_t,
 				   raise() */
+#include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
+				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -125,8 +127,6 @@
 static const char mandos_protocol_version[] = "1";
 const char *argp_program_version = "mandos-client " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
-static const char sys_class_net[] = "/sys/class/net";
-char *connect_to = NULL;
 
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
@@ -554,7 +554,10 @@
   gnutls_session_t session;
   int pf;			/* Protocol family */
   
+  errno = 0;
+  
   if(quit_now){
+    errno = EINTR;
     return -1;
   }
   
@@ -567,6 +570,7 @@
     break;
   default:
     fprintf(stderr, "Bad address family: %d\n", af);
+    errno = EINVAL;
     return -1;
   }
   
@@ -582,11 +586,14 @@
   
   tcp_sd = socket(pf, SOCK_STREAM, 0);
   if(tcp_sd < 0){
+    int e = errno;
     perror("socket");
+    errno = e;
     goto mandos_end;
   }
   
   if(quit_now){
+    errno = EINTR;
     goto mandos_end;
   }
   
@@ -599,11 +606,15 @@
     ret = inet_pton(af, ip, &to.in.sin_addr);
   }
   if(ret < 0 ){
+    int e = errno;
     perror("inet_pton");
+    errno = e;
     goto mandos_end;
   }
   if(ret == 0){
+    int e = errno;
     fprintf(stderr, "Bad address: %s\n", ip);
+    errno = e;
     goto mandos_end;
   }
   if(af == AF_INET6){
@@ -617,6 +628,7 @@
       if(if_index == AVAHI_IF_UNSPEC){
 	fprintf(stderr, "An IPv6 link-local address is incomplete"
 		" without a network interface\n");
+	errno = EINVAL;
 	goto mandos_end;
       }
       /* Set the network interface number as scope */
@@ -629,6 +641,7 @@
   }
   
   if(quit_now){
+    errno = EINTR;
     goto mandos_end;
   }
   
@@ -665,6 +678,7 @@
   }
   
   if(quit_now){
+    errno = EINTR;
     goto mandos_end;
   }
   
@@ -674,11 +688,14 @@
     ret = connect(tcp_sd, &to.in, sizeof(to)); /* IPv4 */
   }
   if(ret < 0){
+    int e = errno;
     perror("connect");
+    errno = e;
     goto mandos_end;
   }
   
   if(quit_now){
+    errno = EINTR;
     goto mandos_end;
   }
   
@@ -689,7 +706,9 @@
     ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
 				   out_size - written));
     if(ret == -1){
+      int e = errno;
       perror("write");
+      errno = e;
       goto mandos_end;
     }
     written += (size_t)ret;
@@ -705,6 +724,7 @@
     }
   
     if(quit_now){
+      errno = EINTR;
       goto mandos_end;
     }
   }
@@ -714,18 +734,21 @@
   }
   
   if(quit_now){
+    errno = EINTR;
     goto mandos_end;
   }
   
   gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
   
   if(quit_now){
+    errno = EINTR;
     goto mandos_end;
   }
   
   do {
     ret = gnutls_handshake(session);
     if(quit_now){
+      errno = EINTR;
       goto mandos_end;
     }
   } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
@@ -735,6 +758,7 @@
       fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
+    errno = EPROTO;
     goto mandos_end;
   }
   
@@ -748,17 +772,21 @@
   while(true){
     
     if(quit_now){
+      errno = EINTR;
       goto mandos_end;
     }
     
     buffer_capacity = incbuffer(&buffer, buffer_length,
 				   buffer_capacity);
     if(buffer_capacity == 0){
+      int e = errno;
       perror("incbuffer");
+      errno = e;
       goto mandos_end;
     }
     
     if(quit_now){
+      errno = EINTR;
       goto mandos_end;
     }
     
@@ -777,12 +805,14 @@
 	  ret = gnutls_handshake(session);
 	  
 	  if(quit_now){
+	    errno = EINTR;
 	    goto mandos_end;
 	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
 	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
+	  errno = EPROTO;
 	  goto mandos_end;
 	}
 	break;
@@ -790,6 +820,7 @@
 	fprintf(stderr, "Unknown error while reading data from"
 		" encrypted session with Mandos server\n");
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
+	errno = EIO;
 	goto mandos_end;
       }
     } else {
@@ -802,12 +833,14 @@
   }
   
   if(quit_now){
+    errno = EINTR;
     goto mandos_end;
   }
   
   do {
     ret = gnutls_bye(session, GNUTLS_SHUT_RDWR);
     if(quit_now){
+      errno = EINTR;
       goto mandos_end;
     }
   } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
@@ -822,6 +855,7 @@
       written = 0;
       while(written < (size_t) decrypted_buffer_size){
 	if(quit_now){
+	  errno = EINTR;
 	  goto mandos_end;
 	}
 	
@@ -829,10 +863,12 @@
 			  (size_t)decrypted_buffer_size - written,
 			  stdout);
 	if(ret == 0 and ferror(stdout)){
+	  int e = errno;
 	  if(debug){
 	    fprintf(stderr, "Error writing encrypted data: %s\n",
 		    strerror(errno));
 	  }
+	  errno = e;
 	  goto mandos_end;
 	}
 	written += (size_t)ret;
@@ -844,17 +880,25 @@
   /* Shutdown procedure */
   
  mandos_end:
-  free(decrypted_buffer);
-  free(buffer);
-  if(tcp_sd >= 0){
-    ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
-  }
-  if(ret == -1){
-    perror("close");
-  }
-  gnutls_deinit(session);
-  if(quit_now){
-    retval = -1;
+  {
+    int e = errno;
+    free(decrypted_buffer);
+    free(buffer);
+    if(tcp_sd >= 0){
+      ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
+    }
+    if(ret == -1){
+      if(e == 0){
+	e = errno;
+      }
+      perror("close");
+    }
+    gnutls_deinit(session);
+    if(quit_now){
+      e = EINTR;
+      retval = -1;
+    }
+    errno = e;
   }
   return retval;
 }
@@ -976,101 +1020,6 @@
   errno = old_errno;
 }
 
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  ssize_t ssret;
-  char *flagname = NULL;
-  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
-		     if_entry->d_name);
-  if(ret < 0){
-    perror("asprintf");
-    return 0;
-  }
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
-  if(flags_fd == -1){
-    perror("open");
-    return 0;
-  }
-  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
-  /* read line from flags_fd */
-  ssize_t to_read = (sizeof(ifreq_flags)*2)+3; /* "0x1003\n" */
-  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
-  flagstring[(size_t)to_read] = '\0';
-  if(flagstring == NULL){
-    perror("malloc");
-    close(flags_fd);
-    return 0;
-  }
-  while(to_read > 0){
-    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
-					     (size_t)to_read));
-    if(ssret == -1){
-      perror("read");
-      free(flagstring);
-      close(flags_fd);
-      return 0;
-    }
-    to_read -= ssret;
-    if(ssret == 0){
-      break;
-    }
-  }
-  close(flags_fd);
-  intmax_t tmpmax;
-  char *tmp;
-  errno = 0;
-  tmpmax = strtoimax(flagstring, &tmp, 0);
-  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
-					 and not (isspace(*tmp)))
-     or tmpmax != (ifreq_flags)tmpmax){
-    if(debug){
-      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
-	      flagstring, if_entry->d_name);
-    }
-    free(flagstring);
-    return 0;
-  }
-  free(flagstring);
-  ifreq_flags flags = (ifreq_flags)tmpmax;
-  /* Reject the loopback device */
-  if(flags & IFF_LOOPBACK){
-    if(debug){
-      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
-    if(debug){
-      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 1;
-  }
-  /* Otherwise, reject non-broadcast-capable devices */
-  if(not (flags & IFF_BROADCAST)){
-    if(debug){
-      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept this device */
-  if(debug){
-    fprintf(stderr, "Interface \"%s\" is acceptable\n",
-	    if_entry->d_name);
-  }
-  return 1;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1078,12 +1027,13 @@
   intmax_t tmpmax;
   char *tmp;
   int exitcode = EXIT_SUCCESS;
-  const char *interface = "";
+  const char *interface = "eth0";
   struct ifreq network;
   int sd = -1;
   bool take_down_interface = false;
   uid_t uid;
   gid_t gid;
+  char *connect_to = NULL;
   char tempdir[] = "/tmp/mandosXXXXXX";
   bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
@@ -1152,11 +1102,21 @@
 	.arg = "SECONDS",
 	.doc = "Maximum delay to wait for interface startup",
 	.group = 2 },
+      /*
+       * These reproduce what we would get without ARGP_NO_HELP
+       */
+      { .name = "help", .key = '?',
+	.doc = "Give this help list", .group = -1 },
+      { .name = "usage", .key = -3,
+	.doc = "Give a short usage message", .group = -1 },
+      { .name = "version", .key = 'V',
+	.doc = "Print program version", .group = -1 },
       { .name = NULL }
     };
     
     error_t parse_opt(int key, char *arg,
 		      struct argp_state *state){
+      errno = 0;
       switch(key){
       case 128:			/* --debug */
 	debug = true;
@@ -1178,8 +1138,7 @@
 	tmpmax = strtoimax(arg, &tmp, 10);
 	if(errno != 0 or tmp == arg or *tmp != '\0'
 	   or tmpmax != (typeof(mc.dh_bits))tmpmax){
-	  fprintf(stderr, "Bad number of DH bits\n");
-	  exit(EXIT_FAILURE);
+	  argp_error(state, "Bad number of DH bits");
 	}
 	mc.dh_bits = (typeof(mc.dh_bits))tmpmax;
 	break;
@@ -1190,28 +1149,46 @@
 	errno = 0;
 	delay = strtof(arg, &tmp);
 	if(errno != 0 or tmp == arg or *tmp != '\0'){
-	  fprintf(stderr, "Bad delay\n");
-	  exit(EXIT_FAILURE);
+	  argp_error(state, "Bad delay");
 	}
 	break;
-      case ARGP_KEY_ARG:
-	argp_usage(state);
-      case ARGP_KEY_END:
+	/*
+	 * These reproduce what we would get without ARGP_NO_HELP
+	 */
+      case '?':			/* --help */
+	argp_state_help(state, state->out_stream,
+			(ARGP_HELP_STD_HELP | ARGP_HELP_EXIT_ERR)
+			& ~(unsigned int)ARGP_HELP_EXIT_OK);
+      case -3:			/* --usage */
+	argp_state_help(state, state->out_stream,
+			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
+      case 'V':			/* --version */
+	fprintf(state->out_stream, "%s\n", argp_program_version);
+	exit(argp_err_exit_status);
 	break;
       default:
 	return ARGP_ERR_UNKNOWN;
       }
-      return 0;
+      return errno;
     }
     
     struct argp argp = { .options = options, .parser = parse_opt,
 			 .args_doc = "",
 			 .doc = "Mandos client -- Get and decrypt"
 			 " passwords from a Mandos server" };
-    ret = argp_parse(&argp, argc, argv, 0, 0, NULL);
-    if(ret == ARGP_ERR_UNKNOWN){
-      fprintf(stderr, "Unknown error while parsing arguments\n");
-      exitcode = EXIT_FAILURE;
+    ret = argp_parse(&argp, argc, argv,
+		     ARGP_IN_ORDER | ARGP_NO_HELP, 0, NULL);
+    switch(ret){
+    case 0:
+      break;
+    case ENOMEM:
+    default:
+      errno = ret;
+      perror("argp_parse");
+      exitcode = EX_OSERR;
+      goto end;
+    case EINVAL:
+      exitcode = EX_USAGE;
       goto end;
     }
   }
@@ -1219,31 +1196,6 @@
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-
-  if(interface[0] == '\0'){
-    struct dirent **direntries;
-    ret = scandir(sys_class_net, &direntries, good_interface,
-		  alphasort);
-    if(ret >= 1){
-      /* Pick the first good interface */
-      interface = strdup(direntries[0]->d_name);
-      if(debug){
-	fprintf(stderr, "Using interface \"%s\"\n", interface);
-      }
-      if(interface == NULL){
-	perror("malloc");
-	free(direntries);
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      free(direntries);
-    } else {
-      free(direntries);
-      fprintf(stderr, "Could not find a network interface\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
   
   /* Initialize Avahi early so avahi_simple_poll_quit() can be called
      from the signal handler */
@@ -1252,7 +1204,7 @@
   mc.simple_poll = avahi_simple_poll_new();
   if(mc.simple_poll == NULL){
     fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
-    exitcode = EXIT_FAILURE;
+    exitcode = EX_UNAVAILABLE;
     goto end;
   }
   
@@ -1260,19 +1212,19 @@
   ret = sigaddset(&sigterm_action.sa_mask, SIGINT);
   if(ret == -1){
     perror("sigaddset");
-    exitcode = EXIT_FAILURE;
+    exitcode = EX_OSERR;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGHUP);
   if(ret == -1){
     perror("sigaddset");
-    exitcode = EXIT_FAILURE;
+    exitcode = EX_OSERR;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGTERM);
   if(ret == -1){
     perror("sigaddset");
-    exitcode = EXIT_FAILURE;
+    exitcode = EX_OSERR;
     goto end;
   }
   /* Need to check if the handler is SIG_IGN before handling:
@@ -1282,49 +1234,49 @@
   ret = sigaction(SIGINT, NULL, &old_sigterm_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &sigterm_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      exitcode = EXIT_FAILURE;
+      exitcode = EX_OSERR;
       goto end;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_sigterm_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &sigterm_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      exitcode = EXIT_FAILURE;
+      exitcode = EX_OSERR;
       goto end;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_sigterm_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &sigterm_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      exitcode = EXIT_FAILURE;
+      exitcode = EX_OSERR;
       goto end;
     }
   }
   
   /* If the interface is down, bring it up */
-  if(strcmp(interface, "none") != 0){
+  if(interface[0] != '\0'){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exitcode = EXIT_FAILURE;
+      exitcode = EX_UNAVAILABLE;
       goto end;
     }
     
@@ -1341,7 +1293,7 @@
     
 #ifdef __linux__
     /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
-       messages to mess up the prompt */
+       messages about the network interface to mess up the prompt */
     ret = klogctl(8, NULL, 5);
     bool restore_loglevel = true;
     if(ret == -1){
@@ -1353,7 +1305,7 @@
     sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
     if(sd < 0){
       perror("socket");
-      exitcode = EXIT_FAILURE;
+      exitcode = EX_OSERR;
 #ifdef __linux__
       if(restore_loglevel){
 	ret = klogctl(7, NULL, 0);
@@ -1382,7 +1334,7 @@
 	}
       }
 #endif	/* __linux__ */
-      exitcode = EXIT_FAILURE;
+      exitcode = EX_OSERR;
       /* Lower privileges */
       errno = 0;
       ret = seteuid(uid);
@@ -1397,8 +1349,8 @@
       ret = ioctl(sd, SIOCSIFFLAGS, &network);
       if(ret == -1){
 	take_down_interface = false;
-	perror("ioctl SIOCSIFFLAGS +IFF_UP");
-	exitcode = EXIT_FAILURE;
+	perror("ioctl SIOCSIFFLAGS");
+	exitcode = EX_OSERR;
 #ifdef __linux__
 	if(restore_loglevel){
 	  ret = klogctl(7, NULL, 0);
@@ -1470,7 +1422,7 @@
   ret = init_gnutls_global(pubkey, seckey);
   if(ret == -1){
     fprintf(stderr, "init_gnutls_global failed\n");
-    exitcode = EXIT_FAILURE;
+    exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
     gnutls_initialized = true;
@@ -1493,7 +1445,7 @@
   
   if(not init_gpgme(pubkey, seckey, tempdir)){
     fprintf(stderr, "init_gpgme failed\n");
-    exitcode = EXIT_FAILURE;
+    exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
     gpgme_initialized = true;
@@ -1509,7 +1461,7 @@
     char *address = strrchr(connect_to, ':');
     if(address == NULL){
       fprintf(stderr, "No colon in address\n");
-      exitcode = EXIT_FAILURE;
+      exitcode = EX_USAGE;
       goto end;
     }
     
@@ -1523,7 +1475,7 @@
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
        or tmpmax != (uint16_t)tmpmax){
       fprintf(stderr, "Bad port number\n");
-      exitcode = EXIT_FAILURE;
+      exitcode = EX_USAGE;
       goto end;
     }
   
@@ -1548,7 +1500,25 @@
     
     ret = start_mandos_communication(address, port, if_index, af);
     if(ret < 0){
-      exitcode = EXIT_FAILURE;
+      switch(errno){
+      case ENETUNREACH:
+      case EHOSTDOWN:
+      case EHOSTUNREACH:
+	exitcode = EX_NOHOST;
+	break;
+      case EINVAL:
+	exitcode = EX_USAGE;
+	break;
+      case EIO:
+	exitcode = EX_IOERR;
+	break;
+      case EPROTO:
+	exitcode = EX_PROTOCOL;
+	break;
+      default:
+	exitcode = EX_OSERR;
+	break;
+      }
     } else {
       exitcode = EXIT_SUCCESS;
     }
@@ -1581,7 +1551,7 @@
   if(mc.server == NULL){
     fprintf(stderr, "Failed to create Avahi server: %s\n",
 	    avahi_strerror(error));
-    exitcode = EXIT_FAILURE;
+    exitcode = EX_UNAVAILABLE;
     goto end;
   }
   
@@ -1596,7 +1566,7 @@
   if(sb == NULL){
     fprintf(stderr, "Failed to create service browser: %s\n",
 	    avahi_strerror(avahi_server_errno(mc.server)));
-    exitcode = EXIT_FAILURE;
+    exitcode = EX_UNAVAILABLE;
     goto end;
   }
   
@@ -1651,10 +1621,10 @@
       if(ret == -1){
 	perror("ioctl SIOCGIFFLAGS");
       } else if(network.ifr_flags & IFF_UP) {
-	network.ifr_flags &= ~IFF_UP; /* clear flag */
+	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS -IFF_UP");
+	  perror("ioctl SIOCSIFFLAGS");
 	}
       }
       ret = (int)TEMP_FAILURE_RETRY(close(sd));

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-08-10 19:08:24 +0000
+++ plugins.d/mandos-client.xml	2009-02-09 02:01:13 +0000
@@ -202,9 +202,8 @@
 	<listitem>
 	  <para>
 	    Network interface that will be brought up and scanned for
-	    Mandos servers to connect to.  The default is the empty
-	    string, which will automatically choose an appropriate
-	    interface.
+	    Mandos servers to connect to.  The default is
+	    <quote><literal>eth0</literal></quote>.
 	  </para>
 	  <para>
 	    If the <option>--connect</option> option is used, this
@@ -221,11 +220,10 @@
 	    by this program.
 	  </para>
 	  <para>
-	    <replaceable>NAME</replaceable> can be the string
-	    <quote><literal>none</literal></quote>; this will not use
-	    any specific interface, and will not bring up an interface
-	    on startup.  This is not recommended, and only meant for
-	    advanced users.
+	    <replaceable>NAME</replaceable> can be the empty string;
+	    this will not use any specific interface, and will not
+	    bring up an interface on startup.  This is not
+	    recommended, and only meant for advanced users.
 	  </para>
 	</listitem>
       </varlistentry>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2009-09-07 07:48:59 +0000
+++ plugins.d/password-prompt.c	2009-10-30 16:23:43 +0000
@@ -37,11 +37,13 @@
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <sys/types.h>		/* ssize_t */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getopt_long, getenv() */
+				   getenv() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
-				   stdin, feof(), perror(), fputc(),
-				   stdout, getopt_long */
-#include <errno.h>		/* errno, EINVAL */
+				   stdin, feof(), perror(), fputc()
+				*/
+#include <errno.h>		/* errno, EBADF, ENOTTY, EINVAL,
+				   EFAULT, EFBIG, EIO, ENOSPC, EINTR
+				*/
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
 #include <string.h> 		/* strlen, rindex, strncmp, strcmp */
@@ -50,6 +52,8 @@
 				   argp_parse(), error_t,
 				   ARGP_KEY_ARG, ARGP_KEY_END,
 				   ARGP_ERR_UNKNOWN */
+#include <sysexits.h>		/* EX_SOFTWARE, EX_OSERR,
+				   EX_UNAVAILABLE, EX_IOERR, EX_OK */
 
 volatile sig_atomic_t quit_now = 0;
 int signal_received;
@@ -82,10 +86,20 @@
 	.doc = "Prefix shown before the prompt", .group = 2 },
       { .name = "debug", .key = 128,
 	.doc = "Debug mode", .group = 3 },
+      /*
+       * These reproduce what we would get without ARGP_NO_HELP
+       */
+      { .name = "help", .key = '?',
+	.doc = "Give this help list", .group = -1 },
+      { .name = "usage", .key = -3,
+	.doc = "Give a short usage message", .group = -1 },
+      { .name = "version", .key = 'V',
+	.doc = "Print program version", .group = -1 },
       { .name = NULL }
     };
     
     error_t parse_opt (int key, char *arg, struct argp_state *state){
+      errno = 0;
       switch (key){
       case 'p':
 	prefix = arg;
@@ -93,25 +107,42 @@
       case 128:
 	debug = true;
 	break;
-      case ARGP_KEY_ARG:
-	argp_usage(state);
-	break;
-      case ARGP_KEY_END:
+	/*
+	 * These reproduce what we would get without ARGP_NO_HELP
+	 */
+      case '?':			/* --help */
+	argp_state_help(state, state->out_stream,
+			(ARGP_HELP_STD_HELP | ARGP_HELP_EXIT_ERR)
+			& ~(unsigned int)ARGP_HELP_EXIT_OK);
+      case -3:			/* --usage */
+	argp_state_help(state, state->out_stream,
+			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
+      case 'V':			/* --version */
+	fprintf(state->out_stream, "%s\n", argp_program_version);
+	exit(argp_err_exit_status);
 	break;
       default:
 	return ARGP_ERR_UNKNOWN;
       }
-      return 0;
+      return errno;
     }
     
     struct argp argp = { .options = options, .parser = parse_opt,
 			 .args_doc = "",
 			 .doc = "Mandos password-prompt -- Read and"
 			 " output a password" };
-    ret = argp_parse(&argp, argc, argv, 0, 0, NULL);
-    if(ret == ARGP_ERR_UNKNOWN){
-      fprintf(stderr, "Unknown error while parsing arguments\n");
-      return EXIT_FAILURE;
+    ret = argp_parse(&argp, argc, argv,
+		     ARGP_IN_ORDER | ARGP_NO_HELP, NULL, NULL);
+    switch(ret){
+    case 0:
+      break;
+    case ENOMEM:
+    default:
+      errno = ret;
+      perror("argp_parse");
+      return EX_OSERR;
+    case EINVAL:
+      return EX_USAGE;
     }
   }
   
@@ -123,25 +154,32 @@
   }
   
   if(tcgetattr(STDIN_FILENO, &t_old) != 0){
+    int e = errno;
     perror("tcgetattr");
-    return EXIT_FAILURE;
+    switch(e){
+    case EBADF:
+    case ENOTTY:
+      return EX_UNAVAILABLE;
+    default:
+      return EX_OSERR;
+    }
   }
   
   sigemptyset(&new_action.sa_mask);
   ret = sigaddset(&new_action.sa_mask, SIGINT);
   if(ret == -1){
     perror("sigaddset");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGHUP);
   if(ret == -1){
     perror("sigaddset");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGTERM);
   if(ret == -1){
     perror("sigaddset");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   /* Need to check if the handler is SIG_IGN before handling:
      | [[info:libc:Initial Signal Actions]] |
@@ -150,37 +188,37 @@
   ret = sigaction(SIGINT, NULL, &old_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      return EXIT_FAILURE;
+      return EX_OSERR;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      return EXIT_FAILURE;
+      return EX_OSERR;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_action);
   if(ret == -1){
     perror("sigaction");
-    return EXIT_FAILURE;
+    return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
-      return EXIT_FAILURE;
+      return EX_OSERR;
     }
   }
   
@@ -190,12 +228,20 @@
   }
   
   t_new = t_old;
-  t_new.c_lflag &= ~ECHO;
+  t_new.c_lflag &= ~(tcflag_t)ECHO;
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
+    int e = errno;
     perror("tcsetattr-echo");
-    return EXIT_FAILURE;
+    switch(e){
+    case EBADF:
+    case ENOTTY:
+      return EX_UNAVAILABLE;
+    case EINVAL:
+    default:
+      return EX_OSERR;
+    }
   }
-
+  
   if(debug){
     fprintf(stderr, "Waiting for input from stdin \n");
   }
@@ -212,22 +258,31 @@
       fprintf(stderr, "%s ", prefix);
     }
     {
-      const char *cryptsource = getenv("cryptsource");
-      const char *crypttarget = getenv("crypttarget");
-      const char *const prompt
-	= "Enter passphrase to unlock the disk";
+      const char *cryptsource = getenv("CRYPTTAB_SOURCE");
+      const char *crypttarget = getenv("CRYPTTAB_NAME");
+      /* Before cryptsetup 1.1.0~rc2 */
+      if(cryptsource == NULL){
+	cryptsource = getenv("cryptsource");
+      }
+      if(crypttarget == NULL){
+	crypttarget = getenv("crypttarget");
+      }
+      const char *const prompt1 = "Unlocking the disk";
+      const char *const prompt2 = "Enter passphrase";
       if(cryptsource == NULL){
 	if(crypttarget == NULL){
-	  fprintf(stderr, "%s: ", prompt);
+	  fprintf(stderr, "%s to unlock the disk: ", prompt2);
 	} else {
-	  fprintf(stderr, "%s (%s): ", prompt, crypttarget);
+	  fprintf(stderr, "%s (%s)\n%s: ", prompt1, crypttarget,
+		  prompt2);
 	}
       } else {
 	if(crypttarget == NULL){
-	  fprintf(stderr, "%s %s: ", prompt, cryptsource);
+	  fprintf(stderr, "%s %s\n%s: ", prompt1, cryptsource,
+		  prompt2);
 	} else {
-	  fprintf(stderr, "%s %s (%s): ", prompt, cryptsource,
-		  crypttarget);
+	  fprintf(stderr, "%s %s (%s)\n%s: ", prompt1, cryptsource,
+		  crypttarget, prompt2);
 	}
       }
     }
@@ -237,7 +292,7 @@
       /* Make n = data size instead of allocated buffer size */
       n = (size_t)ret;
       /* Strip final newline */
-      if(n>0 and buffer[n-1] == '\n'){
+      if(n > 0 and buffer[n-1] == '\n'){
 	buffer[n-1] = '\0';	/* not strictly necessary */
 	n--;
       }
@@ -245,18 +300,55 @@
       while(written < n){
 	ret = write(STDOUT_FILENO, buffer + written, n - written);
 	if(ret < 0){
+	  int e = errno;
 	  perror("write");
-	  status = EXIT_FAILURE;
+	  switch(e){
+	  case EBADF:
+	  case EFAULT:
+	  case EINVAL:
+	  case EFBIG:
+	  case EIO:
+	  case ENOSPC:
+	  default:
+	    status = EX_IOERR;
+	    break;
+	  case EINTR:
+	    status = EXIT_FAILURE;
+	    break;
+	  }
 	  break;
 	}
 	written += (size_t)ret;
       }
+      ret = close(STDOUT_FILENO);
+      if(ret == -1){
+	int e = errno;
+	perror("close");
+	switch(e){
+	case EBADF:
+	  status = EX_OSFILE;
+	  break;
+	case EIO:
+	default:
+	  status = EX_IOERR;
+	  break;
+	}
+      }
       break;
     }
     if(ret < 0){
+      int e = errno;
       if(errno != EINTR and not feof(stdin)){
 	perror("getline");
-	status = EXIT_FAILURE;
+	switch(e){
+	case EBADF:
+	  status = EX_UNAVAILABLE;
+	case EIO:
+	case EINVAL:
+	default:
+	  status = EX_IOERR;
+	  break;
+	}
 	break;
       }
     }
@@ -293,7 +385,7 @@
     fprintf(stderr, "%s is exiting with status %d\n", argv[0],
 	    status);
   }
-  if(status == EXIT_SUCCESS){
+  if(status == EXIT_SUCCESS or status == EX_OK){
     fputc('\n', stderr);
   }
   

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/password-prompt.xml	2009-10-30 16:23:43 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2009-10-30">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -183,8 +183,8 @@
     <title>ENVIRONMENT</title>
     <variablelist>
       <varlistentry>
-	<term><envar>cryptsource</envar></term>
-	<term><envar>crypttarget</envar></term>
+	<term><envar>CRYPTTAB_SOURCE</envar></term>
+	<term><envar>CRYPTTAB_NAME</envar></term>
 	<listitem>
 	  <para>
 	    If set, these environment variables will be assumed to

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2009-09-16 23:28:39 +0000
+++ plugins.d/splashy.c	2009-10-18 16:09:05 +0000
@@ -43,9 +43,16 @@
 				   STDOUT_FILENO, _exit(),
 				   pause() */
 #include <string.h>		/* memcmp() */
-#include <errno.h>		/* errno */
+#include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
+				   ENOENT, ENAMETOOLONG, EMFILE,
+				   ENFILE, ENOMEM, ENOEXEC, EINVAL,
+				   E2BIG, EFAULT, EIO, ETXTBSY,
+				   EISDIR, ELIBBAD, EPERM, EINTR,
+				   ECHILD */
 #include <sys/wait.h>		/* waitpid(), WIFEXITED(),
 				   WEXITSTATUS() */
+#include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
+				   EX_UNAVAILABLE */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
@@ -65,6 +72,7 @@
   DIR *proc_dir = NULL;
   pid_t splashy_pid = 0;
   pid_t splashy_command_pid = 0;
+  int exitstatus = EXIT_FAILURE;
   
   /* Create prompt string */
   {
@@ -90,6 +98,7 @@
     }
     if(ret == -1){
       prompt = NULL;
+      exitstatus = EX_OSERR;
       goto failure;
     }
   }
@@ -99,7 +108,23 @@
     const char splashy_name[] = "/sbin/splashy";
     proc_dir = opendir("/proc");
     if(proc_dir == NULL){
+      int e = errno;
       perror("opendir");
+      switch(e){
+      case EACCES:
+      case ENOTDIR:
+      case ELOOP:
+      case ENOENT:
+      default:
+	exitstatus = EX_OSFILE;
+	break;
+      case ENAMETOOLONG:
+      case EMFILE:
+      case ENFILE:
+      case ENOMEM:
+	exitstatus = EX_OSERR;
+	break;
+      }
       goto failure;
     }
     for(struct dirent *proc_ent = readdir(proc_dir);
@@ -127,6 +152,7 @@
 	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
 	if(ret == -1){
 	  perror("asprintf");
+	  exitstatus = EX_OSERR;
 	  goto failure;
 	}
 	
@@ -138,8 +164,20 @@
 	    free(exe_link);
 	    continue;
 	  }
+	  int e = errno;
 	  perror("lstat");
 	  free(exe_link);
+	  switch(e){
+	  case EACCES:
+	  case ENOTDIR:
+	  case ELOOP:
+	  default:
+	    exitstatus = EX_OSFILE;
+	    break;
+	  case ENAMETOOLONG:
+	    exitstatus = EX_OSERR;
+	    break;
+	  }
 	  goto failure;
 	}
 	if(not S_ISLNK(exe_stat.st_mode)
@@ -163,6 +201,7 @@
     proc_dir = NULL;
   }
   if(splashy_pid == 0){
+    exitstatus = EX_UNAVAILABLE;
     goto failure;
   }
   
@@ -175,51 +214,60 @@
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
       perror("sigaddset");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
       perror("sigaddset");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
       perror("sigaddset");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
+	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
+	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
       perror("sigaction");
+      exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
 	perror("sigaction");
+	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
@@ -236,6 +284,7 @@
   }
   if(splashy_command_pid == -1){
     perror("fork");
+    exitstatus = EX_OSERR;
     goto failure;
   }
   /* Child */
@@ -243,7 +292,31 @@
     if(not interrupted_by_signal){
       const char splashy_command[] = "/sbin/splashy_update";
       execl(splashy_command, splashy_command, prompt, (char *)NULL);
+      int e = errno;
       perror("execl");
+      switch(e){
+      case EACCES:
+      case ENOENT:
+      case ENOEXEC:
+      case EINVAL:
+	_exit(EX_UNAVAILABLE);
+      case ENAMETOOLONG:
+      case E2BIG:
+      case ENOMEM:
+      case EFAULT:
+      case EIO:
+      case EMFILE:
+      case ENFILE:
+      case ETXTBSY:
+      default:
+	_exit(EX_OSERR);
+      case ENOTDIR:
+      case ELOOP:
+      case EISDIR:
+      case ELIBBAD:
+      case EPERM:
+	_exit(EX_OSFILE);
+      }
     }
     free(prompt);
     _exit(EXIT_FAILURE);
@@ -320,12 +393,28 @@
       ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace stdout */
       if(ret == -1){
 	perror("dup2");
-	_exit(EXIT_FAILURE);
+	_exit(EX_OSERR);
       }
-    
+      
       execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
-      perror("execl");
-      _exit(EXIT_FAILURE);
+      {
+	int e = errno;
+	perror("execl");
+	switch(e){
+	case EACCES:
+	case ENOENT:
+	case ENOEXEC:
+	default:
+	  _exit(EX_UNAVAILABLE);
+	case ENAMETOOLONG:
+	case E2BIG:
+	case ENOMEM:
+	  _exit(EX_OSERR);
+	case ENOTDIR:
+	case ELOOP:
+	  _exit(EX_OSFILE);
+	}
+      }
     }
   }
   
@@ -348,5 +437,5 @@
     TEMP_FAILURE_RETRY(pause());
   }
   
-  return EXIT_FAILURE;
+  return exitstatus;
 }

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2009-09-17 04:16:32 +0000
+++ plugins.d/usplash.c	2009-10-30 16:22:31 +0000
@@ -47,6 +47,7 @@
 #include <dirent.h>		/* opendir(), readdir(), closedir() */
 #include <inttypes.h>		/* intmax_t, strtoimax() */
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
+#include <sysexits.h>		/* EX_OSERR, EX_UNAVAILABLE */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
@@ -297,9 +298,11 @@
   size_t buf_len = 0;
   pid_t usplash_pid = -1;
   bool usplash_accessed = false;
+  int status = EXIT_FAILURE;	/* Default failure exit status */
   
   char *prompt = makeprompt();
   if(prompt == NULL){
+    status = EX_OSERR;
     goto failure;
   }
   
@@ -308,6 +311,7 @@
   size_t cmdline_len = 0;
   usplash_pid = find_usplash(&cmdline, &cmdline_len);
   if(usplash_pid == 0){
+    status = EX_UNAVAILABLE;
     goto failure;
   }
   
@@ -320,22 +324,26 @@
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
       perror("sigaddset");
+      status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
       perror("sigaddset");
+      status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
       perror("sigaddset");
+      status = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
 	perror("sigaction");
+	status = EX_OSERR;
       }
       goto failure;
     }
@@ -344,6 +352,7 @@
       if(ret == -1){
 	if(errno != EINTR){
 	  perror("sigaction");
+	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -352,6 +361,7 @@
     if(ret == -1){
       if(errno != EINTR){
 	perror("sigaction");
+	status = EX_OSERR;
       }
       goto failure;
     }
@@ -360,6 +370,7 @@
       if(ret == -1){
 	if(errno != EINTR){
 	  perror("sigaction");
+	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -368,6 +379,7 @@
     if(ret == -1){
       if(errno != EINTR){
 	perror("sigaction");
+	status = EX_OSERR;
       }
       goto failure;
     }
@@ -376,6 +388,7 @@
       if(ret == -1){
 	if(errno != EINTR){
 	  perror("sigaction");
+	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -387,6 +400,7 @@
   if(not usplash_write(&fifo_fd, "TIMEOUT", "0")){
     if(errno != EINTR){
       perror("usplash_write");
+      status = EX_OSERR;
     }
     goto failure;
   }
@@ -398,6 +412,7 @@
   if(not usplash_write(&fifo_fd, "INPUTQUIET", prompt)){
     if(errno != EINTR){
       perror("usplash_write");
+      status = EX_OSERR;
     }
     goto failure;
   }
@@ -415,6 +430,7 @@
   if(outfifo_fd == -1){
     if(errno != EINTR){
       perror("open");
+      status = EX_OSERR;
     }
     goto failure;
   }
@@ -433,6 +449,7 @@
       if(tmp == NULL){
 	if(errno != EINTR){
 	  perror("realloc");
+	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -444,6 +461,7 @@
     if(sret == -1){
       if(errno != EINTR){
 	perror("read");
+	status = EX_OSERR;
       }
       TEMP_FAILURE_RETRY(close(outfifo_fd));
       goto failure;
@@ -458,6 +476,7 @@
   if(ret == -1){
     if(errno != EINTR){
       perror("close");
+      status = EX_OSERR;
     }
     goto failure;
   }
@@ -470,6 +489,7 @@
   if(not usplash_write(&fifo_fd, "TIMEOUT", "15")){
     if(errno != EINTR){
       perror("usplash_write");
+      status = EX_OSERR;
     }
     goto failure;
   }
@@ -482,6 +502,7 @@
   if(ret == -1){
     if(errno != EINTR){
       perror("close");
+      status = EX_OSERR;
     }
     goto failure;
   }
@@ -495,6 +516,7 @@
       if(sret == -1){
 	if(errno != EINTR){
 	  perror("write");
+	  status = EX_OSERR;
 	}
 	goto failure;
       }
@@ -523,7 +545,7 @@
   
   /* If usplash was never accessed, we can stop now */
   if(not usplash_accessed){
-    return EXIT_FAILURE;
+    return status;
   }
   
   /* Close FIFO */
@@ -555,7 +577,7 @@
       if(tmp == NULL){
 	perror("realloc");
 	free(cmdline_argv);
-	return EXIT_FAILURE;
+	return status;
       }
       cmdline_argv = tmp;
       cmdline_argv[cmdline_argc] = cmdline + position;
@@ -591,7 +613,7 @@
     ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
     if(ret == -1){
       perror("dup2");
-      _exit(EXIT_FAILURE);
+      _exit(EX_OSERR);
     }
     
     execv(usplash_name, cmdline_argv);
@@ -600,7 +622,7 @@
     }
     free(cmdline);
     free(cmdline_argv);
-    _exit(EXIT_FAILURE);
+    _exit(EX_OSERR);
   }
   free(cmdline);
   free(cmdline_argv);
@@ -638,5 +660,5 @@
     TEMP_FAILURE_RETRY(pause());
   }
   
-  return EXIT_FAILURE;
+  return status;
 }

